
// Code lifted from verbatim environments in the text
// Only changes should be added declarations.

#include <stdlib.h>
#include "ad++.h"

void main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  {
    Procs2 p(2, 2) ;
    if(p.on()) {
      Range x(100, p.dim(0), BLK), y(10, p.dim(1), BLK) ;

      Array2<float> a(x, y) ;

      for(x.where() ; x.test() ; x.next()) {
	for(y.where() ; y.test() ; y.next()) {
	  a(x, y) = x + y ;
	} y.erewh() ;
      } x.erewh() ;

      Subscript i(x(75)), j(y(1)) ;

      if(i.at()) {
	if(j.at()) {
	  a(i, j) = 76 ;
	} j.ta() ;
      } i.ta() ;
    } p.no() ;
  }
  {
    Procs2 p(2, 2) ;

    if(p.on()) {
      Range x(100, p.dim(0), BLK), y(10, p.dim(1), BLK) ;

      Array2<float> a(x, y) ;

      for(x.where() ; x.test() ; x.next()) {
	for(y.where() ; y.test() ; y.next()) {
	  a(x, y) = x + y ;
	} y.erewh() ;
      } x.erewh() ;

    } p.no() ;
  }
  {
    const int N = 512 ;
    const int RESOLUTION = 255 ;

    Procs2 p(2, 2) ;

    if(p.on()) {
      Range x(N, p.dim(0), BLK), y(N, p.dim(1), BLK) ;

      Array2<float> colour(x, y) ;

      for(x.where() ; x.test() ; x.next()) {
	for(y.where() ; y.test() ; y.next()) {
	  float cr = (4.0 * x - 2 * N) / (N - 1) ;
	  float ci = (4.0 * y - 2 * N) / (N - 1) ;
	  float zr = cr, zi = ci ;

	  for (int i = 0 ; i < RESOLUTION &&
			   (zr * zr + zi * zi) < 4.0 ; i++) {
	    zr = cr + zr * zr - zi * zi + cr ;
	    zi = ci + 2 * zr * zi ;
	  }

	  colour (x, y) = i ;
	} y.erewh() ;
      } x.erewh() ;

    } p.no() ;
  }
  {
    const int N = 64 ;
    Procs2 p(2, 2) ;

    if(p.on()) {
      Range x(N, p.dim(0), BLK), y(N, p.dim(1), BLK) ;

      Array2<float> w(x, y) ;

      // ... some code to initialise `w'

      Array2<float> wnx(x, y), wpx(x, y), wny(x, y), wpy(x, y) ;

      shift(wnx, w,  1, 0, EDGE) ;
      shift(wpx, w, -1, 0, EDGE) ;
      shift(wny, w,  1, 1, EDGE) ;
      shift(wpy, w, -1, 1, EDGE) ;

      for(x.where() ; x.test() ; x.next()) {
	for(y.where() ; y.test() ; y.next()) {
	  if(x != 0 && x != N - 1 && y != 0 && y != N - 1)
	    w(x, y) = 0.25 *
		(wnx(x, y) + wpx(x, y) + wny(x, y) + wpy(x, y)) ;
	} y.erewh() ;
      } x.erewh() ;

    } p.no() ;
  }
  {
    const int N = 64 ;
    Procs2 p(2, 2) ;

    if(p.on()) {
      Range x(N, p.dim(0), BLK), y(N, p.dim(1), BLK) ;

      Array2<int> c(x, y) ;

      // ... some code to initialise `c'

      Array2<int> cn_(x, y), cp_(x, y), c_n(x, y), c_p(x, y),
		  cnn(x, y), cnp(x, y), cpn(x, y), cpp(x, y) ;

      shift(cn_, c,  1, 0, CYCL) ;
      shift(cp_, c, -1, 0, CYCL) ;
      shift(c_n, c,  1, 1, CYCL) ;
      shift(c_p, c, -1, 1, CYCL) ;
      shift(cnn, cn_,  1, 1, CYCL) ;
      shift(cnp, cn_, -1, 1, CYCL) ;
      shift(cpn, cp_,  1, 1, CYCL) ;
      shift(cpp, cp_, -1, 1, CYCL) ;

      for(x.where() ; x.test() ; x.next()) {
	for(y.where() ; y.test() ; y.next()) {
	  switch (cn_(x, y) + cp_(x, y) + c_n(x, y) + c_p(x, y) +
		  cnn(x, y) + cnp(x, y) + cpn(x, y) + cpp(x, y)) {
	    case 2 :
	      break ;
	    case 3 :
	      c(x, y) = 1 ;
	      break ;
	    default :
	      c(x, y) = 0 ;
	      break ;
	  }
	} y.erewh() ;
      } x.erewh() ;

    } p.no() ;
  }
  {
    const int N = 64 ;
    Procs2 p(2, 2) ;

    if(p.on()) {
      Range x(N, p.dim(0), BLK), y(N, p.dim(1), BLK) ;

      Array2<float> w(x, y) ;

      Array2<float> wnx(x, y), wpx(x, y), wny(x, y), wpy(x, y) ;

      Range u(N - 2, 1, x), v(N - 2, 1, y) ;

      for(u.where() ; u.test() ; u.next()) {
	for(v.where() ; v.test() ; v.next()) {
	  w(u, v) = 0.25 *
	      (wnx(u, v) + wpx(u, v) + wny(u, v) + wpy(u, v)) ;
	} v.erewh() ;
      } u.erewh() ;

      for(x.where() ; x.test() ; x.next()) {
	for(y.where() ; y.test() ; y.next()) {
	  if(x != 0 && x != N - 1 && y != 0 && y != N - 1)
	    w(x, y) = x + y ;
	} y.erewh() ;
      } x.erewh() ;

      for(u.where() ; u.test() ; u.next()) {
	for(v.where() ; v.test() ; v.next()) {
	  w(u, v) = x(u) + y(v) ;
	} v.erewh() ;
      } u.erewh() ;

      Range t(10, 20, 2, x) ;
    } p.no() ;
  }
  {
    Procs2 p(2, 2) ;
    Procs1 q(3) ;

    Range x(10, p.dim(0), BLK), y(10, p.dim(1), BLK) ;
    Array2<float> a(p, x, y) ;

    Range z(100, q.dim(0), BLK) ;
    Array1<int> b(q, z) ;

    if(p.on()) {
      // ... some code processing `a'
    } p.no() ;

    if(q.on()) {
      // ... some code processing `b'
    } q.no() ;
  }
  {
    Procs2 p(4, 4) ;

    Range x(20, p.dim(0), BLK), y(20, p.dim(1), BLK) ;

    Subscript i(x(12)), j(y(7)) ;

    ProcessGroup q(p / i) ;
    ProcessGroup r(p / j) ;
    ProcessGroup s(q / j) ;
  }
  {
    Procs1 p(6) ;
    if(p.on()) {
      Procs2 r(2, 2) ;

      Range x(100, r.dim(1), BLK) ;
      ProcessGroup q(r / x(50)) ;

      // ...
    } p.no() ;
  }
  {
    Procs2 p(2, 2) ;

    Range x(10, p.dim(0), BLK) ;
    Range y(10, p.dim(1), BLK) ;
    
    Array2<int> a(p, x, y) ;

    Range u(8, 1, x) ;
    Range v(8, 1, y) ;

    Array2<int> b(a, sect(u, v)) ;

    Subscript i(y(5)) ;
    Array1<int> c(a, sect(x, i)) ;

    Array1<int> d(p / i, x) ;
  }
  {
    const int N = 64 ;
    Procs1 p(4) ;

    Range x(N, p.dim(0), BLK) ;
    Array1<float> a(x), b(x) ;

    shift(a, b, 1, 0, EDGE) ;

    Range u(N - 1, 1, x), v(N - 1, 0, x) ;
    remap(Array1<float>(a, sect(u)), Array1<float>(b, sect(v))) ;
  }
  {
    Procs2 p(2, 2) ;
    if(p.on()) {
      Range x(10, p.dim(0), BLK) ;
      Range y(10, p.dim(1), BLK) ;
      
      Array2<int> a(x, y) ;
      Array1<int> b(x) ;
      Array0<int> c ;

      Array0<int> d(a, sect(x(5), y(5))) ;
      remap(c, Array0<int>(a, sect(x(5), y(5)))) ;

      for(x.where() ; x.test() ; x.next()) {
	for(y.where() ; y.test() ; y.next()) {
	  a(x, y) = b(x) ;
	} y.erewh() ;
      } x.erewh() ;

      for(x.where() ; x.test() ; x.next()) {
	for(y.where() ; y.test() ; y.next()) {
	  b(x) = a(x, y) ;
	} y.erewh() ;
      } x.erewh() ;
    } p.no() ;
  }
  {
    Range x(100) ;
    Array1<float> a(x) ;

    Procs1 p(4) ;
    Range y(100, p.dim(0), BLK) ;
    Array1<float> b(p, y) ;

    // ... initialize `b'

    remap(a, b) ;
  }
  {
    const int d = 0 ;
    Procs1 p(4) ;

    Range y(100, p.dim(d), CYC) ;
    Range z(100, p.dim(d), CYC, 10) ;
    Range w(100, p.dim(d), STP) ;
  }
  {
    const int N = 64 ;
    Procs2 p(2, 2) ;

    if(p.on()) {
      Range x(N, p.dim(0), BLK), y(N, p.dim(1), BLK) ;

      Array2<int> a(x, y), b(x, y) ;

      for(y.where() ; y.test() ; y.next()) {
	shift(Array1<int>(b, sect(x, y)),
	      Array1<int>(a, sect(x, y)), y, 0, CYCL) ;
      } y.erewh() ;
    } p.no() ;
  }
  {
    SArray2<float> a(10, 10) ;
    SArray1<float> b(20) ;

    a(5, 5) = b(10) ;
  }
  {
    Procs2 p(2, 2) ;
    if(p.on()) {
      Range x(10, p.dim(0), BLK) ;
      Range y(10, p.dim(1), BLK) ;
      
      float a ;
      Array2<float> b(x, y, a) ;
    } p.no() ;
  }
  {
    Procs3 p(2, 2, 2) ;
    if(p.on()) {
      Range x(10, p.dim(0), BLK) ;
      Range y(10, p.dim(1), BLK) ;
      Range z(10, p.dim(2), BLK) ;
      
      Array2<int> a(x, y) ;
      Array3<int> b(x, z, y, a, seq(0, 2)) ;
    } p.no() ;
  }
  {
    Procs2 p(2, 2) ;
    if(p.on()) {
      Range x(10, p.dim(0), BLK) ;
      Range y(10, p.dim(1), BLK) ;
      
      SArray2<int> a(10, 10) ;
      Array2<int> b(x, y, a) ;
    } p.no() ;
  }
  {
    const int N = 64 ;
    Procs1 p(4) ;

    if(p.on()) {
      Range x(N, p.dim(0), BLK) ;

      Array1<int> a(x) ;

      for(x.where() ; x.test() ; x.next()) {
	a(x) = x ;
      } x.erewh() ;

      x.at() ;
      for(x.locBlocksEnum() ; x.locBlocksTest() ;
			      x.locBlocksNext()) {
	char* aData = a.dat() + a.str(0).offset(x) ;
	int   aStep = a.str(0).step(x) ;
	int   xGlob = x ;
	int   xStep = x.blockStep() ;
	int   count = x.blockCount() ;
	for(int i = 0 ; i < count ; i++)
	  *((int*) (aData + i * aStep)) = xGlob + i * xStep ;
      }
      x.ta() ;

      x.at() ;
      for(x.locBlocksEnum() ; x.locBlocksTest() ;
			      x.locBlocksNext()) {
	char* aData = a.dat() + a.str(0).offset(x) ;
	int   aStep = a.str(0).step(x) ;
	int   xGlob = x ;
	int   xStep = x.blockStep() ;
	int   count = x.blockCount() ;
	for(int i = 0 ; i < count ; i++) {
	  *((int*) aData) = xGlob ;
	  aData += aStep ;
	  xGlob += xStep ;
	}
      }
      x.ta() ;
    } p.no() ;
  }
  {
    Procs2 p(2, 2) ;
    if(p.on()) {
      Range x(10, p.dim(0), BLK) ;
      Range y(10, p.dim(1), BLK) ;
      
      Array2<float> a(x, y) ;
      Array1<float> b(x) ;

      for(x.where() ; x.test() ; x.next()) {
	for(y.where() ; y.test() ; y.next()) {
	  a(x, y) = b(x) ;
	} y.erewh() ;
      } x.erewh() ;

      for(x.locBlocksEnum() ; x.locBlocksTest() ;
			      x.locBlocksNext()) {
	char* aData0 = a.dat() + a.str(0).offset(x) ;
	int   aStep0 = a.str(0).step(x) ;
	char* bData0 = b.dat() + b.str(0).offset(x) ;
	int   bStep0 = b.str(0).step(x) ;
	int   count0 = x.blockCount() ;
	for(int i0 = 0 ; i0 < count0 ; i0++) {
	  for(y.locBlocksEnum() ; y.locBlocksTest() ;
				  y.locBlocksNext()) {
	    char* aData1 = aData0 + a.str(1).offset(y) ;
	    int   aStep1 = a.str(1).step(y) ;
	    int   count1 = y.blockCount() ;
	    for(int i1 = 0 ; i1 < count1 ; i1++) {
	      *((float*) aData1) = *((float*) bData0) ;
	      aData1 += aStep1 ;
	    }
	  }
	  bData0 += bStep0 ;
	  aData0 += aStep0 ;
	}
      }
    } p.no() ;
  }
  {
    const int N = 64 ;
    Procs2 p(2, 2) ;

    if(p.on()) {
      Range x(N, p.dim(0), BLK), y(N, p.dim(1), BLK) ;

      Array2<float> w(x, y) ;

      // ... some code to initialise `w'

      // Create the communication schedules...

      Array2<float> wnx(x, y), wpx(x, y), wny(x, y), wpy(x, y) ;

      Shift nx(wnx, w,  1, 0, EDGE) ;
      Shift px(wpx, w, -1, 0, EDGE) ;
      Shift ny(wny, w,  1, 1, EDGE) ;
      Shift py(wpy, w, -1, 1, EDGE) ;

      Range u(N - 2, 1, x), v(N - 2, 1, y) ;

      // Following code goes in a loop...

      nx.execute() ;
      px.execute() ;
      ny.execute() ;
      py.execute() ;

      for(u.where() ; u.test() ; u.next()) {
	for(v.where() ; v.test() ; v.next()) {
	  w(u, v) = 0.25 *
	      (wnx(u, v) + wpx(u, v) + wny(u, v) + wpy(u, v)) ;
	} v.erewh() ;
      } u.erewh() ;

    } p.no() ;
  }
  {
    const int typeLen = 4 ;
    const int rank    = 2 ;
    Stride strs [rank] ;
    Range  rngs [rank] ;
    
    int size = typeLen ;
    for(int i = 0 ; i < rank ; i++)
      strs [i] = Stride(rngs [i], &size) ;
  }
  {
    const int typeLen = 4 ;
    const int rank    = 2 ;
    Stride strs [rank] ;
    Range  rngs [rank] ;
    
    int size = typeLen ;
    for(int i = rank - 1 ; i >= 0 ; i--)
      strs [i] = Stride(rngs [i], &size) ;
  }
  AdlibFinalize() ;
}

